function varargout = Rifled(varargin)
% RIFLED M-file for Rifled.fig
%      RIFLED, by itself, creates a new RIFLED or raises the existing
%      singleton*.
%
%      H = RIFLED returns the handle to a new RIFLED or the handle to
%      the existing singleton*.
%
%      RIFLED('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RIFLED.M with the given input arguments.
%
%      RIFLED('Property','Value',...) creates a new RIFLED or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Rifled_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Rifled_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Rifled

% Last Modified by GUIDE v2.5 24-Aug-2006 20:16:30

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @Rifled_OpeningFcn, ...
    'gui_OutputFcn',  @Rifled_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Rifled is made visible.
function Rifled_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Rifled (see VARARGIN)

% Choose default command line output for Rifled
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Rifled wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% Print an initial plot based on the default data.
[r, t, e, s, f] = rb2(2000, 125, 1.5, .25, 200, 500, 50);
plot(r,t,'r-'); % r- is red solid line.
xlabel('Range [yard]');
ylabel('Elevation [inch]');
grid on;
axis([0 300 -36 24])
title('Trajectory');

% set the radio buttons default
set(handles.radiobuttonTrajectory,'Value',1);
set(handles.radiobuttonEnergy,    'Value',0);
set(handles.radiobuttonSpeed,     'Value',0);
set(handles.radiobuttonFlight,    'Value',0);

% --- Outputs from this function are returned to the command line.
function varargout = Rifled_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function editLoadName_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editLoadName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function editLoadName_Callback(hObject, eventdata, handles)
% hObject    handle to editLoadName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editLoadName as text
%        str2double(get(hObject,'String')) returns contents of editLoadName as a double
%LoadName = str2double(get(hObject,'string'));


% --- Executes during object creation, after setting all properties.
function editMuzzleVelocity_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMuzzleVelocity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function editMuzzleVelocity_Callback(hObject, eventdata, handles)
% hObject    handle to editMuzzleVelocity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
user_entry=str2double(get(hObject,'string'));
if isnan(user_entry)
    errordlg('Enter a numeric value.','User Input Error','modal');
    %    set(hObject,'string','ERROR');
    return;
end
if user_entry > 4500 || user_entry < 400
    errordlg('Range Error - try again.','User Input Error','modal');
    %    set(hObject,'string','ERROR');
    return;
end

% Hints: get(hObject,'String') returns contents of editMuzzleVelocity as text
%        str2double(get(hObject,'String')) returns contents of editMuzzleVelocity as a double


% --- Executes during object creation, after setting all properties.
function editBulletWeight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editBulletWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function editBulletWeight_Callback(hObject, eventdata, handles)
% hObject    handle to editBulletWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
user_entry=str2double(get(hObject,'string'));
if isnan(user_entry)
    errordlg('Enter a numeric value.','User Input Error','modal');
    return;
end
if user_entry > 500 || user_entry < 1
    errordlg('Range Error - try again.','User Input Error','modal');
    return;
end

% Hints: get(hObject,'String') returns contents of editBulletWeight as text
%        str2double(get(hObject,'String')) returns contents of editBulletWeight as a double


% --- Executes during object creation, after setting all properties.
function editBallisticCoefficient_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editBallisticCoefficient (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function editBallisticCoefficient_Callback(hObject, eventdata, handles)
% hObject    handle to editBallisticCoefficient (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
user_entry=str2double(get(hObject,'string'));
if isnan(user_entry)
    errordlg('Enter a numeric value.','User Input Error','modal');
    return;
end
if user_entry > 5 || user_entry < 0.001
    errordlg('Range Error - try again.','User Input Error','modal');
    return;
end

% Hints: get(hObject,'String') returns contents of editBallisticCoefficient as text
%        str2double(get(hObject,'String')) returns contents of
%        editBallisticCoefficient as a double


% --- Executes during object creation, after setting all properties.
function editTargetRange_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editTargetRange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function editTargetRange_Callback(hObject, eventdata, handles)
% hObject    handle to editTargetRange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
user_entry=str2double(get(hObject,'string'));
if isnan(user_entry)
    errordlg('Enter a numeric value.','User Input Error','modal');
    return;
end
if user_entry > 1000 || user_entry < 50
    errordlg('Range Error - try again.','User Input Error','modal');
    return;
end

% Hints: get(hObject,'String') returns contents of editTargetRange as text
%        str2double(get(hObject,'String')) returns contents of editTargetRange as a double


% --- Executes during object creation, after setting all properties.
function editScopeHeight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editScopeHeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function editScopeHeight_Callback(hObject, eventdata, handles)
% hObject    handle to editScopeHeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
user_entry=str2double(get(hObject,'string'));
if isnan(user_entry)
    errordlg('Enter a numeric value.','User Input Error','modal');
    return;
end
if user_entry > 6 || user_entry < 0.001
    errordlg('Range Error - try again.','User Input Error','modal');
    return;
end

% Hints: get(hObject,'String') returns contents of editScopeHeight as text
%        str2double(get(hObject,'String')) returns contents of editScopeHeight as a double



% --- Executes during object creation, after setting all properties.
function editAltitude_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editAltitude (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function editAltitude_Callback(hObject, eventdata, handles)
% hObject    handle to editAltitude (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editAltitude as text
%        str2double(get(hObject,'String')) returns contents of editAltitude as a double
user_entry=str2double(get(hObject,'string'));
if isnan(user_entry)
    errordlg('Enter a numeric value.','User Input Error','modal');
    return;
end
if user_entry > 25000 || user_entry < -500
    errordlg('Range Error - try again.','User Input Error','modal');
    return;
end

% --- Executes during object creation, after setting all properties.
function editTemperature_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editTemperature (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function editTemperature_Callback(hObject, eventdata, handles)
% hObject    handle to editTemperature (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editTemperature as text
%        str2double(get(hObject,'String')) returns contents of editTemperature as a double
user_entry=str2double(get(hObject,'string'));
if isnan(user_entry)
    errordlg('Enter a numeric value.','User Input Error','modal');
    return;
end
if user_entry > 120 || user_entry < -60
    errordlg('Range Error - try again.','User Input Error','modal');
    return;
end

% --- Executes on button press in firebutton.
function firebutton_Callback(hObject, eventdata, handles)
% hObject    handle to firebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% This is the main section that integrates the user inputs and produces PLOTs.
BulletWeight = str2double(get(handles.editBulletWeight,'String'));
MuzzleVelocity = str2double(get(handles.editMuzzleVelocity,'String'));
ScopeHeight = str2double(get(handles.editScopeHeight,'String'));
BallisticCoefficient = str2double(get(handles.editBallisticCoefficient,'String'));
TargetRange = str2double(get(handles.editTargetRange,'String'));
Altitude = str2double(get(handles.editAltitude,'String'));
Temperature = str2double(get(handles.editTemperature,'String'));

% Get the pop-up menu selections 1-4.
pop1Val = get(handles.popupmenu1,'Value');
pop1List = get(handles.popupmenu1,'String');
pop1Name = pop1List{pop1Val};
LoadData=get(handles.popupmenu1,'UserData'); 

pop2Val = get(handles.popupmenu2,'Value');
pop2List = get(handles.popupmenu2,'String');
pop2Name = pop2List{pop2Val};

pop3Val = get(handles.popupmenu3,'Value');
pop3List = get(handles.popupmenu3,'String');
pop3Name = pop3List{pop3Val};

pop4Val = get(handles.popupmenu4,'Value');
pop4List = get(handles.popupmenu4,'String');
pop4Name = pop1List{pop4Val};

MV1=LoadData(pop1Val,1);
BW1=LoadData(pop1Val,2); 
BC1=LoadData(pop1Val,3);

MV2=LoadData(pop2Val,1);
BW2=LoadData(pop2Val,2); 
BC2=LoadData(pop2Val,3);

MV3=LoadData(pop3Val,1);
BW3=LoadData(pop3Val,2); 
BC3=LoadData(pop3Val,3);

MV4=LoadData(pop4Val,1);
BW4=LoadData(pop4Val,2); 
BC4=LoadData(pop4Val,3);

% Get the graph type from radio buttons. Only one should be selected.
if get(handles.radiobuttonTrajectory,'Value') == 1
    graphType=1; % Trajectory
else if get(handles.radiobuttonEnergy,'Value') == 1
        graphType=2; % Energy
    else if get(handles.radiobuttonSpeed,'Value') == 1
            graphType=3; % Velocity
        else if get(handles.radiobuttonFlight,'Value') == 1
                graphType = 4; % Flight
            else msgbox('graphType Error'); return;
            end
        end
    end
end
% msgbox(graphType);

% output range, trajectory, energy, speed, flight
%msgbox('This is a message box');
% [r(1,:) t(1,:) e(1,:) s(1,:) f(1,:)] = rb2(MuzzleVelocity, BulletWeight, ScopeHeight, BallisticCoefficient, TargetRange, Altitude, Temperature);
% Handle velocity errors during flight - occur when table2 errors - increase M. Velocity, B. Coefficient or reduce T. Range.
try    
    [r t e s f] = rb2(MuzzleVelocity, BulletWeight, ScopeHeight, BallisticCoefficient, TargetRange, Altitude, Temperature);
catch
    msgbox('Velocity Range Error during flight - try again.');
    return;
end
hold off;
switch graphType
    case 1      % Trajectory
        plot(r,t,'r-') % r- is red solid line.
        xlabel('Range [yard]');
        ylabel('Elevation [inch]');
        grid on;
        axis([0 1.5*TargetRange -36 24])
        title('Trajectory');
        if MV1 ~= 0
            try
                [r t e s f] = rb2(MV1, BW1, ScopeHeight, BC1, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,t,'b-');
            hold off;
        end
        if MV2 ~= 0
            try
                [r t e s f] = rb2(MV2, BW2, ScopeHeight, BC2, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,t,'m-');
            hold off;
        end
        if MV3 ~= 0
            try
                [r t e s f] = rb2(MV3, BW3, ScopeHeight, BC3, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,t,'c-');
            hold off;
        end
        if MV4 ~= 0
            try
                [r t e s f] = rb2(MV4, BW4, ScopeHeight, BC4, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,t,'g-');
            hold off;
        end
    case 2      % Energy
        plot(r,e,'r-'); % r- is red solid line.
        xlabel('Range [yard]');
        ylabel('Energy [ft-lb]');
        grid on;
        axis auto;
        title('Energy vs. Range');
        if MV1 ~= 0
            try
                [r t e s f] = rb2(MV1, BW1, ScopeHeight, BC1, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,e,'b-');
            hold off;
        end
        if MV2 ~= 0
            try
                [r t e s f] = rb2(MV2, BW2, ScopeHeight, BC2, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,e,'m-');
            hold off;
        end
        if MV3 ~= 0
            try
                [r t e s f] = rb2(MV3, BW3, ScopeHeight, BC3, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,e,'c-');
            hold off;
        end
        if MV4 ~= 0
            try
                [r t e s f] = rb2(MV4, BW4, ScopeHeight, BC4, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,e,'g-');
            hold off;
        end
    case 3      % Speed
        plot(r,s,'r-'); % r- is red solid line.
        xlabel('Range [yard]');
        ylabel('Velocity [fps]');
        grid on;
        axis auto;
        title('Velocity vs. Range');
        if MV1 ~= 0
            try
                [r t e s f] = rb2(MV1, BW1, ScopeHeight, BC1, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,s,'b-');
            hold off;
        end
        if MV2 ~= 0
            try
                [r t e s f] = rb2(MV2, BW2, ScopeHeight, BC2, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,s,'m-');
            hold off;
        end
        if MV3 ~= 0
            try
                [r t e s f] = rb2(MV3, BW3, ScopeHeight, BC3, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,s,'c-');
            hold off;
        end
        if MV4 ~= 0
            try
                [r t e s f] = rb2(MV4, BW4, ScopeHeight, BC4, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,s,'g-');
            hold off;
        end
    case 4      % Flight
        plot(r,f,'r-'); % r- is red solid line.
        xlabel('Range [yard]');
        ylabel('Time of Flight [sec.]');
        grid on;
        axis auto;
        title('Time of Flight vs. Range');
        if MV1 ~= 0
            try
                [r t e s f] = rb2(MV1, BW1, ScopeHeight, BC1, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,f,'b-');
            hold off;
        end
        if MV2 ~= 0
            try
                [r t e s f] = rb2(MV2, BW2, ScopeHeight, BC2, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,f,'m-');
            hold off;
        end
        if MV3 ~= 0
            try
                [r t e s f] = rb2(MV3, BW3, ScopeHeight, BC3, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,f,'c-');
            hold off;
        end
        if MV4 ~= 0
            try
                [r t e s f] = rb2(MV4, BW4, ScopeHeight, BC4, TargetRange, Altitude, Temperature);
            catch
                msgbox('Velocity Range Error during flight - try again.');
                return;
            end
            hold on;
            plot(r,f,'g-');
            hold off;
        end
    otherwise
        msgbox('Unknown Graph Type');
        return;
end

% Figure out the legend. Take all combinations of 4 inputs i.e. 16
% combinations. There must be a better way.
if pop1Val == 1 && pop2Val == 1 && pop3Val == 1 && pop4Val == 1  % 0000
    legend(get(handles.editLoadName,'String'), 0);
end
if pop1Val ~= 1 && pop2Val == 1 && pop3Val == 1 && pop4Val == 1  % 0001
    legend(get(handles.editLoadName,'String'), pop1Name, 0);
end
if pop1Val == 1 && pop2Val ~= 1 && pop3Val == 1 && pop4Val == 1  % 0010
    legend(get(handles.editLoadName,'String'), pop2Name, 0);
end
if pop1Val ~= 1 && pop2Val ~= 1 && pop3Val == 1 && pop4Val == 1  % 0011
    legend(get(handles.editLoadName,'String'), pop1Name, pop2Name, 0);
end
if pop1Val == 1 && pop2Val == 1 && pop3Val ~= 1 && pop4Val == 1  % 0100
    legend(get(handles.editLoadName,'String'), pop3Name, 0);
end
if pop1Val ~= 1 && pop2Val == 1 && pop3Val ~= 1 && pop4Val == 1  % 0101
    legend(get(handles.editLoadName,'String'), pop1Name, pop3Name, 0);
end
if pop1Val == 1 && pop2Val ~= 1 && pop3Val ~= 1 && pop4Val == 1  % 0110
    legend(get(handles.editLoadName,'String'), pop2Name, pop3Name, 0);
end
if pop1Val ~= 1 && pop2Val ~= 1 && pop3Val ~= 1 && pop4Val == 1  % 0111
    legend(get(handles.editLoadName,'String'), pop1Name, pop2Name, pop3Name, 0);
end
if pop1Val == 1 && pop2Val == 1 && pop3Val == 1 && pop4Val ~= 1  % 1000
    legend(get(handles.editLoadName,'String'), pop4Name, 0);
end
if pop1Val ~= 1 && pop2Val == 1 && pop3Val == 1 && pop4Val ~= 1  % 1001
    legend(get(handles.editLoadName,'String'), pop1Name, pop4Name, 0);
end
if pop1Val == 1 && pop2Val ~= 1 && pop3Val == 1 && pop4Val ~= 1  % 1010
    legend(get(handles.editLoadName,'String'), pop2Name, pop4Name, 0);
end
if pop1Val ~= 1 && pop2Val ~= 1 && pop3Val == 1 && pop4Val ~= 1  % 1011
    legend(get(handles.editLoadName,'String'), pop1Name, pop2Name, pop4Name, 0);
end
if pop1Val == 1 && pop2Val == 1 && pop3Val ~= 1 && pop4Val ~= 1  % 1100
    legend(get(handles.editLoadName,'String'), pop3Name, pop4Name, 0);
end
if pop1Val ~= 1 && pop2Val == 1 && pop3Val ~= 1 && pop4Val ~= 1  % 1101
    legend(get(handles.editLoadName,'String'), pop1Name, pop3Name, pop4Name, 0);
end
if pop1Val == 1 && pop2Val ~= 1 && pop3Val ~= 1 && pop4Val ~= 1  % 1110
    legend(get(handles.editLoadName,'String'), pop2Name, pop3Name, pop4Name, 0);
end
if pop1Val ~= 1 && pop2Val ~= 1 && pop3Val ~= 1 && pop4Val ~= 1  % 1111
    legend(get(handles.editLoadName,'String'), pop1Name, pop2Name, pop3Name, pop4Name, 0);
end


% --- Executes on button press in printbutton.
function printbutton_Callback(hObject, eventdata, handles)
% hObject    handle to printbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
print;

% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over firebutton.
function firebutton_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to firebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbuttonExit.
function pushbuttonExit_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonExit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close ALL;


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1


% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2


% --- Executes during object creation, after setting all properties.
function popupmenu3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popupmenu3.
function popupmenu3_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu3


% --- Executes during object creation, after setting all properties.
function popupmenu4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popupmenu4.
function popupmenu4_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu4 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu4


% --- Executes on button press in radiobuttonTrajectory.
function radiobuttonTrajectory_Callback(hObject, eventdata, handles)
% hObject    handle to radiobuttonTrajectory (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.radiobuttonTrajectory,'Value',1);
set(handles.radiobuttonEnergy,    'Value',0);
set(handles.radiobuttonSpeed,     'Value',0);
set(handles.radiobuttonFlight,    'Value',0);

% Hint: get(hObject,'Value') returns toggle state of radiobuttonTrajectory


% --- Executes on button press in radiobuttonEnergy.
function radiobuttonEnergy_Callback(hObject, eventdata, handles)
% hObject    handle to radiobuttonEnergy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.radiobuttonTrajectory,'Value',0);
set(handles.radiobuttonEnergy,    'Value',1);
set(handles.radiobuttonSpeed,     'Value',0);
set(handles.radiobuttonFlight,    'Value',0);

% Hint: get(hObject,'Value') returns toggle state of radiobuttonEnergy


% --- Executes on button press in radiobuttonSpeed.
function radiobuttonSpeed_Callback(hObject, eventdata, handles)
% hObject    handle to radiobuttonSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.radiobuttonTrajectory,'Value',0);
set(handles.radiobuttonEnergy,    'Value',0);
set(handles.radiobuttonSpeed,     'Value',1);
set(handles.radiobuttonFlight,    'Value',0);

% Hint: get(hObject,'Value') returns toggle state of radiobuttonSpeed


% --- Executes on button press in radiobuttonFlight.
function radiobuttonFlight_Callback(hObject, eventdata, handles)
% hObject    handle to radiobuttonFlight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.radiobuttonTrajectory,'Value',0);
set(handles.radiobuttonEnergy,    'Value',0);
set(handles.radiobuttonSpeed,     'Value',0);
set(handles.radiobuttonFlight,    'Value',1);
% Hint: get(hObject,'Value') returns toggle state of radiobuttonFlight


% For each Caliber enter Muzzle Velocity, Bullet Weight, Ballistic Coefficient.
% The 1st line is zero
%LoadData(:,:) = [ 0 0 0;
%    1176 110 .1405; % 38 Special, 110g
%    1296 110 .109;  % 357 magnum, 110g
%    1235 158 .161;  % 357 magnum, 158g
%    1155 115 .155;  % 9mm Luger, 115g
%    850  230 .1535; % 45 ACP, 230g
%    1140 40  .158;  % 22 LR, 40g
%    3240 55  .218;  % 223 rem, 55g
%    3350 80  .283;  % 243 Win, 80g
%    3060 130 .372;  % 270 Win. 130g
%    3110 150 .382;  % 7mm rem mag, 150g
%    2390 150 .214;  % 30-30 win. 150g
%    2365 125 .296   % AK47 7.62x29mm, 125g
%    2820 150 .349;  % 308 win, 150g
%    2910 150 .348;  % 30-06 spring., 150g
%    2960 180 .485;  % 300 win mag, 180g
%    2780 225 .481;  % 338 win mag, 225g
%    2520 350 .376;  % 416 rem mag, 350g
%    2040 500 .384]  % 458 win mag, 500g



